.st ########qksort	sort an array

.pg
.hl 1 qksort#-#sort an array
.s 4
.c ;**********
.c ;* qksort *
.c ;**********
.s 2
.lm +4.nf
.i -4;Usage
qksort(array, num__elements, elt__size, qkcmp);
??? array[];		The array to sort.
unsigned int num__elements;	The number of elements in
				the array.
int elt__size;		sizeof an array element.
int (*qkcmp)();		user-supplied routine which
			compares two array elements.
.s
.i -4;description
.br
.fill
Sort the array. The user must supply the routine which qksort
calls to compare two array elements. The routine is called as:
"qkcmp(a, b)  BYTE *a, *b;", and must return
a value just like strcmp does:
.nf
	a < b  returns -1
	a == b returns 0
	a > b  returns +1
.s
.fill
For example:
.nf
 int int__array[10];	integer array
 char *str__array[10];	array of pointers to strings
 qksort(int__array, 10, sizeof(int), _&int__cmp);
 qksort(str__array, 10, sizeof(char *), _&str__cmp);
 *********************
 int__cmp(a, b)
 int *a, *b;
 {
 return (*a - *b);
 }
.s
 **********************
 str__cmp(a, b)
 char *a[], *b[];
 {
 return (strcmp(*a, *b));
 }
.s
.i -4; Bugs/Restrictions/Comments:
.br
.fill
The performance is best if array elements are aligned on
word boundaries. This will be the case if the array is of
int's, etc, or pointers to strings. The obvious choice for
strings is for it to be an array of pointers to
strings, anyway.
.s
This routine is NOT recursive, requires minimal stack space,
and is efficient for any existing order in the original array,
even if it is already sorted, in reverse order, or
has all equal elements.
.s
This is the slickest quicksort I have ever come across, and I
have been collecting them for several years.
.s
.i -4;Author:
.br
.nf
 Ray Van Tassle
 13 Apr 1982
.lm -4.fill
